/*
  Based on Formalize.
*/



// Used by buttons, tabs, and menu links.
@mixin pointer-target {
  font-size: 0.9em;
  // line-height: 1;
  // letter-spacing: 0.08em;
  padding: $pointer_target-padding;
  display: inline-block;
  text-decoration: none;
  font-weight: 600;

  // ----- Doesn't include:
  // text-transform
  // color
  // background
  // borders
}



/*------------------------------------------------------------------------
                              UI Consistency
*/
input[type="search"]::-webkit-search-decoration {
  display: none;
}

input,
button,
a.button,
select,
textarea {
  // Suppress red glow that Firefox
  // adds to form fields by default.
  &:invalid {
    box-shadow: none;
  }

  // Add blue glow.
  &:focus {
    border-color: transparent !important;
    box-shadow: $colour-blue 0 0 0 2px;
    // for Opera
    z-index: 1;
  }
}

input[type="file"],
input[type="radio"],
input[type="checkbox"] {
  &:focus,
  &:active {
    box-shadow: none;
  }
}

.form-checkboxes,
.form-radios {
  @include group;
}

fieldset {
  border-top-width: 1px;
  margin-bottom: 3em;

  legend {
    margin-top: 0.3em;
    margin-bottom: 0.3em;
  }
  * + & {
    margin-top: 3em;
  }
}

input[type="radio"],
input[type="checkbox"] {
  margin-top: 0.3em;
}

label {
  font-weight: 600;
  line-height: 1.1;
  min-width: 5em;
  display: inline-block;

  main & {
    font-size: 1.1em;
  }

  input[type="radio"] + &,
  input[type="checkbox"] + & {
    min-width: 0;
    padding-left: 0.2em;
  }
}



/*------------------------------------------------------------------------
                              Buttons
*/
button,
a.button,
input[type="reset"],
input[type="submit"],
input[type="button"] {
  // -webkit-appearance: none;
  appearance: none;
  border-radius: 0;
  background-clip: padding-box;
  border: none;
  border-color: $colour-yellow;
  cursor: pointer;
  color:  $colour-dark-turquois;
  display: inline-block;
  outline: 0;
  overflow: visible;
  margin-top: 0.6em;
  margin-right: 0.6em;
  padding: 3px 10px;
  text-decoration: none;
  vertical-align: top;
  width: auto;
  margin: 0;
  background-color: $colour-yellow;
  text-transform: capitalize;
  width: 100%;
  box-sizing: border-box;
  text-align: center;

  &.button:hover,
  &.button:focus {
    color: $colour-dark-turquois;
  }

  @include pointer-target;
  padding: 0.4em 0.8em;
  font-size: 2em;
  text-transform: uppercase;
  font-weight: 600;

  &:hover,
  &:focus {
    text-decoration: none;
  }

  &:active {
    box-shadow: inset rgba(black, 0.25) 0 1px 2px 0;
    border-color: #999 #bbb #ddd;
  }

  // Kill phantom spacing and dotted
  // border that appears in Firefox.
  &::-moz-focus-inner {
    border: 0;
    padding: 0;
  }

  &.primary,
  &.button-primary {}
}



/*------------------------------------------------------------------------
                              Text Fields
*/
textarea,
select,
input[type="date"],
input[type="datetime"],
input[type="datetime-local"],
input[type="email"],
input[type="month"],
input[type="number"],
input[type="password"],
input[type="search"],
input[type="tel"],
input[type="text"],
input[type="time"],
input[type="url"],
input[type="week"] {
  box-sizing: border-box;
  background-clip: padding-box;
  border-radius: 0;
  -webkit-appearance: none;
  background-color: white;
  border: none;
  border-color: #848484 #c1c1c1 #e1e1e1;
  color: black;
  outline: 0;
  margin: 0;
  padding: $data-field-padding;
  text-align: left;
  font-size: 1em;
  height: auto;
  vertical-align: top;
  transition: all, $transition-duration-regular, ease;
  max-width: 100%;
  padding: 1.5em 0.8em;
  border-bottom: solid $colour-yellow;
  width: 100%;
  background-color: #e3e3e3;
  cursor: pointer;
  @media all and (max-width: 500px)  {
    padding: 1em 0.8em;
  }
  &[disabled] {
    background-color: #eee;
  }
}
.resizable-textarea {
  textarea {
    border-bottom-left-radius: 0;
    border-bottom-right-radius: 0;
  }
}



/*------------------------------------------------------------------------
                              Other
*/
button[disabled],
input[disabled],
select[disabled],
select[disabled] option,
select[disabled] optgroup,
textarea[disabled],
a.button_disabled {
  box-shadow: none;
  -moz-user-select: -moz-none;
  -webkit-user-select: none;
  -khtml-user-select: none;
  user-select: none;
  color: #888;
  cursor: default;
}

// Separate rule for Firefox.
// Separate rule for IE, too.
// Cannot stack with WebKit's.
input::-webkit-input-placeholder,
textarea::-webkit-input-placeholder {
  color: #888;
}

input:-moz-placeholder,
textarea:-moz-placeholder {
  color: #888;
}

input.placeholder_text,
textarea.placeholder_text {
  color: #888;
}

textarea,
select[size],
select[multiple] {
  height: auto;
}



/*------------------------------------------------------------------------
                              Select lists
*/
// Set height back to normal,
// for Opera, WebKit, and IE.
select[size="0"],
select[size="1"] {
  height: 1.8em;
}

// Tweaks for Safari + Chrome.
@media (-webkit-min-device-pixel-ratio: 0) {
  select[size],
  select[multiple],
  select[multiple][size] {
    background-image: none;
    padding-right: 3px;
  }

  select,
  select[size="0"],
  select[size="1"] {
    // Base64 encoded "../images/select_arrow.gif"
    background-repeat: no-repeat;
    background-position: right center;
    padding-right: 20px;
  }

  ::-webkit-validation-bubble-message {
    -webkit-box-shadow: none;
    box-shadow: none;
    background: -webkit-gradient(linear, left top, left bottom, color-stop(0, #666), color-stop(1, black));
    border: 0;
    color: white;
    // font: 13px/17px "Lucida Grande", Arial, "Liberation Sans", FreeSans, sans-serif;
    overflow: hidden;
    padding: 15px 15px 17px;
    text-shadow: black 0 0 1px;
    min-height: 16px;
  }

  ::-webkit-validation-bubble-arrow,
  ::-webkit-validation-bubble-top-outer-arrow,
  ::-webkit-validation-bubble-top-inner-arrow {
    -webkit-box-shadow: none;
    box-shadow: none;
    background: #666;
    border-color: #666;
  }
}



/*------------------------------------------------------------------------
                              Other elements
*/
textarea {
  min-height: 40px;
  overflow: auto;
  resize: vertical;
  width: 100%;
}

optgroup {
  color: black;
  font-style: normal;
  font-weight: normal;

  // Kill phantom spacing and dotted
  // border that appears in Firefox.
  &::-moz-focus-inner {
    border: 0;
    padding: 0;
  }
}